Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
xuanvi

viết chữ theo đường thẳng bất kỳ bằng auto Lisp

Các bài được khuyến nghị

xuanvi    0

Có pác nào giúp em với.

 

Em có nhiều đường thẳng khác nhau trên một bản vẽ mà cần ghi các thông số chi tiết lên đường thẳng đó (ví dụ: em cần ghi đường kính các ống cấp nước là D32 lên tất cảc các đường thẳng trên). Vậy có pác nào viết dùm em một cái lisp mà mình có thể nhập đoạn text từ bàn phím rồi chèn đoạn text đó theo đường thẳng bất kỳ không? các đường thẳng tiếp theo chỉ cần chọn là chèn đoạn text vào, lệnh sẽ kết thúc khi ta nhần enter hoặc ESC.

 

PS:

đoạn Text được chèn vào nằm đúng giữa đường thẳng và có góc quay song song với đoạn thẳng đó.

 

Cám ơn các pác.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
q288    164
Có pác nào giúp em với.

 

Em có nhiều đường thẳng khác nhau trên một bản vẽ mà cần ghi các thông số chi tiết lên đường thẳng đó (ví dụ: em cần ghi đường kính các ống cấp nước là D32 lên tất cảc các đường thẳng trên). Vậy có pác nào viết dùm em một cái lisp mà mình có thể nhập đoạn text từ bàn phím rồi chèn đoạn text đó theo đường thẳng bất kỳ không? các đường thẳng tiếp theo chỉ cần chọn là chèn đoạn text vào, lệnh sẽ kết thúc khi ta nhần enter hoặc ESC.

 

PS:

đoạn Text được chèn vào nằm đúng giữa đường thẳng và có góc quay song song với đoạn thẳng đó.

 

Cám ơn các pác.

Bạn thử dùng cái này xem. Kiểu chữ và chiều cao chữ do bạn chọn trước khi vào lệnh.

(defun c:int ()
 (setq ss (ssget '((0 . "LINE")))
  chu (getstring "Chen chu :"))
 (setq os (getvar "OSMODE"))
 (setvar "OSMODE" 0)
 (repeat (sslength ss)
(setq v  (ssname ss 0)
  p1 (cdr (assoc 10 (entget v)))
  p2 (cdr (assoc 11 (entget v)))
  pm (polar p1 (angle p1 p2) (* 0.5 (distance p1 p2)))
)
(command "text" "j" "MC" pm "" (* 180 (/ (angle p1 p2) pi)) chu)
(ssdel v ss)
 )
 (setvar "OSMODE" os)
)

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
huyhuong    14

Bạn thử dùng cái này xem. Kiểu chữ và chiều cao chữ do bạn chọn trước khi vào lệnh.

 

 

mình đã thử lisp của bạn và có ý kiến như sau"

+ lisp chỉ dùng được với line, với polyline,... thì không dùng được

+ dòng text theo mình nghĩ thì lên đặt bên trên đường thẳng. dòng text này nên tạo sẵn trong cad chứ nhập từ dòng commad thì đánh chữ có dấu rất khó, hoặc là chèn những ký tự toán học vào cũng phức tạp.

hy vọng bạn sẽ hoàn thiện lisp trên. cảm ơn bạn rất nhiều.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
q288    164
mình đã thử lisp của bạn và có ý kiến như sau"

+ lisp chỉ dùng được với line, với polyline,... thì không dùng được

+ dòng text theo mình nghĩ thì lên đặt bên trên đường thẳng. dòng text này nên tạo sẵn trong cad chứ nhập từ dòng commad thì đánh chữ có dấu rất khó, hoặc là chèn những ký tự toán học vào cũng phức tạp.

hy vọng bạn sẽ hoàn thiện lisp trên. cảm ơn bạn rất nhiều.

 

mình theo yêu cầu của bạn xuanvi mà, nếu bạn yêu cầu thì mình sửa cũng đc, nhưng để xuanvi có ý kiến thế nào đã.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
xuanvi    0

Cám ơn bạn q288 đã có bài viết. Mình đã dùng thử, thấy rất được. Tuy nhiên mình còn một vấn đề cần bạn giúp là:

 

Sau khi chèn text vào đường thẳng đã chọn rồi, con chuột vẫn ở rạng "ô vuông", mình chọn đường thẳng khác nó lại chèn đoạn text trên vào đường thẳng mình vừa chọn. Lệnh sẽ kết thúc khi mình nhấn Enter hoặc ESC.

 

Mình xin giải thích: Trên bản vẽ có nhiều đoạn line, mình muốn chèn một đoạn text cố định vào tất cả các đường line đó. chỉ cần một lệnh: chọn line chèn text, chọn line chèn text,....enter, esc -->kết thúc lệnh. Như vậy giảm được rất nhiều thời gian.

 

Cám ơn bạn huyhuong đã có ý kiến đóng góp. Tuy nhiên ở đây mình chỉ cần ghi các thông số kỹ thuật lên đoạn line đó thôi, không cần ghi tiếng việt có dấu. thông số kỹ thuật có thể khác nhau theo từng trường hợp, do vậy đoạn text mình phải nhập vào từ bàn phím.

 

Để text nằm trên đoạn thẳng mình chỉ cần thay "MC" bằng "BC" như đoạn mã dưới đây là được:

 

(command "text" "j" "BC" pm "" (* 180 (/ (angle p1 p2) pi)) chu)

 

Nếu bạn q288 mà viết cho cả đường pline thì tốt.

 

PS:

 

Hơn nữa, bạn cần xử lý góc chèn text, để text không bị ngược như khi ta chèn text vào đoạn thẳng mà được vẽ từ phải qua trái ( Điểm p1 bên phải, p2 bên trái theo trục thẳng đứng)

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
q288    164
Cám ơn bạn q288 đã có bài viết. Mình đã dùng thử, thấy rất được. Tuy nhiên mình còn một vấn đề cần bạn giúp là:

 

Sau khi chèn text vào đường thẳng đã chọn rồi, con chuột vẫn ở rạng "ô vuông", mình chọn đường thẳng khác nó lại chèn đoạn text trên vào đường thẳng mình vừa chọn. Lệnh sẽ kết thúc khi mình nhấn Enter hoặc ESC.

 

Mình xin giải thích: Trên bản vẽ có nhiều đoạn line, mình muốn chèn một đoạn text cố định vào tất cả các đường line đó. chỉ cần một lệnh: chọn line chèn text, chọn line chèn text,....enter, esc -->kết thúc lệnh. Như vậy giảm được rất nhiều thời gian.

 

Cám ơn bạn huyhuong đã có ý kiến đóng góp. Tuy nhiên ở đây mình chỉ cần ghi các thông số kỹ thuật lên đoạn line đó thôi, không cần ghi tiếng việt có dấu. thông số kỹ thuật có thể khác nhau theo từng trường hợp, do vậy đoạn text mình phải nhập vào từ bàn phím.

 

Nếu bạn q288 mà viết cho cả đường pline thì tốt.

 

PS:

 

Hơn nữa, bạn cần xử lý góc chèn text, để text không bị ngược như khi ta chèn text vào đoạn thẳng mà được vẽ từ phải qua trái ( Điểm p1 bên phải, p2 bên trái theo trục thẳng đứng)

 

Bạn thử cái này xem sao, nếu k muốn chèn nữa thì enter hơn là esc, vì esc làm thoát lệnh giữa chừng sẽ mất osnap.

(defun c:int(/ chu os ent obj ndai p1 p2 pm ang dau1)
 (setq	chu (getstring "Chen chu :")
	os (getvar "OSMODE")
ent (car (entsel "\nChon duong de chen :")))
 (setvar "OSMODE" 0)

 (while ent
(setq obj  (vlax-ename->vla-object ent)
  ndai (/ (vlax-curve-getDistAtParam obj (vlax-curve-getEndParam obj)) 2)
  pr   (vlax-curve-getParamAtDist obj ndai)  
  p1   (vlax-curve-getPointAtParam obj (- pr 0.1))
  p2   (vlax-curve-getPointAtParam obj (+ pr 0.1))
  pm   (vlax-curve-getPointAtParam obj pr)
  ang  (if (< (car p1) (car p2)) (angle p1 p2) (angle p2 p1))
)
(command "text" "j" "BC" pm "" (* 180 (/ ang pi)) chu)
(setq ent (car (entsel "\nChon duong de chen :")))
 )
 (setvar "OSMODE" os)
)

  • Vote tăng 3

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
xuanvi    0

ôi, hay quá! cám ơn bạn q288 rất nhiều. Mình là người mới bắt đầu học lisp, nên loay hoay mãi mà không ra.

 

cái này rất giúp ích cho mình trong thiết kế.

 

Ah, mà bạn viết bằng cái gì vậy, có cả mầu cho các lệnh, dấu ngoặc vậy? Mình viết bằng notepad nên theo dõi rất khó khăn.

 

Bạn có tài liệu hướng dẫn lập trình lisp mà dễ hiểu không, chỉ cho mình với. Mỗi lần làm cái gì lại đi nhờ vả, ngại lắm!!!

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
xuanvi    0

bạn q288 ơi, cho mình hỏi chút: tại sao khi AP lên máy này thì được, AP lên máy khác lại không được?

 

Có một vấn đề nảy sinh:

 

- Text nhập vào sẽ lấy theo font của style hiện tại (current style). Không can thiệp được chiều cao của text.

- Nếu dùng lệnh "ST", thay đổi chiều cao chữ trong ô "Height" của style hiện hành thì chương trình sẽ có lỗi xảy ra: ví dụ text sẽ nhảy thành số, góc nghiêng không song song với đường thẳng đã chọn.

 

vậy mình có thể yêu cầu nhập vào chiều cao của đoạn text được không? như vậy không ảnh hưởng bởi style hiện tại mà có thể tuỳ chọn chiều cao text cho phù hợp.

 

mong sớm nhận được giúp đỡ của mọi người.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
q288    164
ôi, hay quá! cám ơn bạn q288 rất nhiều. Mình là người mới bắt đầu học lisp, nên loay hoay mãi mà không ra.

cái này rất giúp ích cho mình trong thiết kế.

Ah, mà bạn viết bằng cái gì vậy, có cả mầu cho các lệnh, dấu ngoặc vậy? Mình viết bằng notepad nên theo dõi rất khó khăn.

Bạn có tài liệu hướng dẫn lập trình lisp mà dễ hiểu không, chỉ cho mình với. Mỗi lần làm cái gì lại đi nhờ vả, ngại lắm!!!

 

Trong diễn đàn nếu muốn viết có màu thì để đoạn code ở giữa cặp code ... /code nếu là đoạn code ngắn, hoặc codebox... /codebox nếu là code dài (có dấu [] . Ở phía dưới có nút "trợ giúp BB code" đó).

Còn khi viết lisp thì mình dùng trình soạn thảo của visual lisp (trong acad đánh lệnh vlide).

Về tài liệu thì mình chẳng đọc cái gì khác ngoài help của acad và visual lisp (nhấn f1), ngoài ra mình xem các ct ng khác viết rồi đoạn code nào thấy hay hay mình bắt chước (dĩ nhiên phải hiểu nó làm công việc gì mới đc) . Cái quan trọng nhất là thuật toán, cái đó mình phải tự suy nghĩ chứ k bắt chước ai đc.

Chúc bạn thành công.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
q288    164
bạn q288 ơi, cho mình hỏi chút: tại sao khi AP lên máy này thì được, AP lên máy khác lại không được?

 

À mình quên thêm dòng (vl-load-com) ở đầu ct. Không hiểu sao các cad 2007 về sau họ không tự động load các hàm visual lisp như các cad cũ hơn. Tốt nhất bạn nên để dòng đó vào file acad.lsp và vào options->system->chọn "load acad.lsp with every drawing" để khỏi phải bận tâm cứ phải load với từng lệnh.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
q288    164
bạn q288 ơi, cho mình hỏi chút: tại sao khi AP lên máy này thì được, AP lên máy khác lại không được?

 

Có một vấn đề nảy sinh:

 

- Text nhập vào sẽ lấy theo font của style hiện tại (current style). Không can thiệp được chiều cao của text.

- Nếu dùng lệnh "ST", thay đổi chiều cao chữ trong ô "Height" của style hiện hành thì chương trình sẽ có lỗi xảy ra: ví dụ text sẽ nhảy thành số, góc nghiêng không song song với đường thẳng đã chọn.

 

vậy mình có thể yêu cầu nhập vào chiều cao của đoạn text được không? như vậy không ảnh hưởng bởi style hiện tại mà có thể tuỳ chọn chiều cao text cho phù hợp.

 

mong sớm nhận được giúp đỡ của mọi người.

 

Mình sửa lại như sau, tên lệnh đổi lại là ist vì int trùng với intersect của acad. Cao chữ nhập 1 lần, lần sau nếu k muốn đổi thì enter.

(defun c:ist(/ chu os ent obj ndai p1 p2 pm ang caoc)
 (setq	chu (getstring "Chen chu :")
caoc (getreal (strcat "\nCao chu <" (rtos (getvar "USERR1")) ">:"))
	os (getvar "OSMODE")
ent (car (entsel "\nChon duong de chen :")))
 (setvar "OSMODE" 0)
 (if (not caoc) (setq caoc (getvar "USERR1")) (setvar "USERR1" caoc))
 (while ent
(setq obj  (vlax-ename->vla-object ent)
  ndai (/ (vlax-curve-getDistAtParam obj (vlax-curve-getEndParam obj)) 2)
  pr   (vlax-curve-getParamAtDist obj ndai)  
  p1   (vlax-curve-getPointAtParam obj (- pr 0.1))
  p2   (vlax-curve-getPointAtParam obj (+ pr 0.1))
  pm   (vlax-curve-getPointAtParam obj pr)
  ang  (if (< (car p1) (car p2)) (angle p1 p2) (angle p2 p1))
)
(command "text" "j" "BC" pm caoc (* 180 (/ ang pi)) chu)
(setq ent (car (entsel "\nChon duong de chen :")))
 )
 (setvar "OSMODE" os)
)

  • Vote tăng 2

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
w1nDream    73
Mình sửa lại như sau, tên lệnh đổi lại là ist vì int trùng với intersect của acad. Cao chữ nhập 1 lần, lần sau nếu k muốn đổi thì enter.

(defun c:ist(/ chu os ent obj ndai p1 p2 pm ang caoc)
 (setq	chu (getstring "Chen chu :")
caoc (getreal (strcat "\nCao chu <" (rtos (getvar "USERR1")) ">:"))
	os (getvar "OSMODE")
ent (car (entsel "\nChon duong de chen :")))
 (setvar "OSMODE" 0)
 (if (not caoc) (setq caoc (getvar "USERR1")) (setvar "USERR1" caoc))
 (while ent
(setq obj  (vlax-ename->vla-object ent)
  ndai (/ (vlax-curve-getDistAtParam obj (vlax-curve-getEndParam obj)) 2)
  pr   (vlax-curve-getParamAtDist obj ndai)  
  p1   (vlax-curve-getPointAtParam obj (- pr 0.1))
  p2   (vlax-curve-getPointAtParam obj (+ pr 0.1))
  pm   (vlax-curve-getPointAtParam obj pr)
  ang  (if (< (car p1) (car p2)) (angle p1 p2) (angle p2 p1))
)
(command "text" "j" "BC" pm caoc (* 180 (/ ang pi)) chu)
(setq ent (car (entsel "\nChon duong de chen :")))
 )
 (setvar "OSMODE" os)
)

 

Pác q288 có thể fát triển nó thành viết chữ theo đường path có sẵn được hok?Cái này cũng đã nhiều người hỏi nhưng chắc vẫn chưa có câu trả lời xác đáng.

Hiện tại thì chi viết dạng Arctext (chỉ nhận đường arc).Còn Pl và Spl thì chịu.Hi vọng pác q288 và các tiền bối có thể giúp đỡ.thks!

:bigsmile:

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
ngo_tieu_my    0

chủ thớt hình như là dân nước. nếu vậy thì bạn có thể chỉnh dim để tạo dim ghi theo mẫu VD D200-i=0.02-l= xxx trong đó là xxx là chiều dài đoạn thẳng khi bạn ghi chiều dài đoạn thẳng đó như bình thường thì sẽ ra y như mẫu, chiều dài = chiều dai đo. nói thì hơi khó hiểu. có gì ban pm Ym ht33n19586 mình sẽ send cho mẫu.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
mhspirit    1

Mình sửa lại như sau, tên lệnh đổi lại là ist vì int trùng với intersect của acad. Cao chữ nhập 1 lần, lần sau nếu k muốn đổi thì enter.

(defun c:ist(/ chu os ent obj ndai p1 p2 pm ang caoc)
 (setq	chu (getstring "Chen chu :")
caoc (getreal (strcat "\nCao chu <" (rtos (getvar "USERR1")) ">:"))
	os (getvar "OSMODE")
ent (car (entsel "\nChon duong de chen :")))
 (setvar "OSMODE" 0)
 (if (not caoc) (setq caoc (getvar "USERR1")) (setvar "USERR1" caoc))
 (while ent
(setq obj  (vlax-ename->vla-object ent)
 	ndai (/ (vlax-curve-getDistAtParam obj (vlax-curve-getEndParam obj)) 2)
 	pr   (vlax-curve-getParamAtDist obj ndai)  
 	p1   (vlax-curve-getPointAtParam obj (- pr 0.1))
 	p2   (vlax-curve-getPointAtParam obj (+ pr 0.1))
 	pm   (vlax-curve-getPointAtParam obj pr)
 	ang  (if (< (car p1) (car p2)) (angle p1 p2) (angle p2 p1))
)
(command "text" "j" "BC" pm caoc (* 180 (/ ang pi)) chu)
(setq ent (car (entsel "\nChon duong de chen :")))
 )
 (setvar "OSMODE" os)
)

làm sao viết chữ tiếng việt được đây bạn,thanks

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Doan Van Ha    2.676

làm sao viết chữ tiếng việt được đây bạn,thanks

Để viết được các câu tiếng Việt:

1). Chọn text sytle có font có thể viết được tiếng Việt.

2). Trong lisp, thay dòng (getstring "Chen chu :") bởi dòng (getstring T "Chen chu :")

  • Vote tăng 2

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
RNDCE    0

Gửi bạn Doan Van Ha,

Nhờ bạn chỉnh lại một chút ist.lsp được không:

 Thay vì pick từng line để thêm text, bạn có thể chỉnh để mình quét cửa sổ chọn nhiều đối tượng một lúc rối thêm text cho nhanh hơn không.

Mong phản hồi sớm của bạn.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
minhtri2701    5

bác Doan Van HA xem giúp là líp này sao đánh nhiều chử không được vậy??

 

vd : đánh D20 thì được, nhưng đánh ống pvc D20 lại không được, khi đánh dấu cách thì lisp lại chuyển sang nhập chiều cao chử!!

 

thanks

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Tot77    501

Các bác cứ réo bác HA làm chi, lisp này có từ năm 2009, bác HA có "phê" thêm năm 2012, từ đó tới giờ chẳng ai đụng tới nữa.

Bác HA có vẻ không thích sửa lisp của người khác, thôi thì tôi sửa dùm cho các bác "làm phước" vậy.

 

(defun c:ist(/ chu os ent obj ndai p1 p2 pm ang caoc)
  (setq chu (getstring t "Chen chu :")
caoc (getreal (strcat "\nCao chu <" (rtos (getvar "USERR1")) ">:"))
os (getvar "OSMODE"))
  (prompt "\nChon duong de chen :")
  (setq ent (ssget '((0 . "LINE"))) n -1)
  (setvar "OSMODE" 0)
  (if (not caoc) (setq caoc (getvar "USERR1")) (setvar "USERR1" caoc))
  (repeat (sslength ent)
    (setq obj  (vlax-ename->vla-object (ssname ent (setq n (1+ n))))
 ndai (/ (vlax-curve-getDistAtParam obj (vlax-curve-getEndParam obj)) 2)
 pr   (vlax-curve-getParamAtDist obj ndai)  
 p1   (vlax-curve-getPointAtParam obj (- pr 0.1))
 p2   (vlax-curve-getPointAtParam obj (+ pr 0.1))
 pm   (vlax-curve-getPointAtParam obj pr)
 ang  (if (< (car p1) (car p2)) (angle p1 p2) (angle p2 p1))
)
(command "text" "j" "BC" pm caoc (* 180 (/ ang pi)) chu)
  )
  (setvar "OSMODE" os)
)
  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
phamhieu236    0

Command: (LOAD "C:/Users/146LTN/Desktop/ist.lsp") ; error: syntax error
Lisp e tải về để ở màn hình.khi load vào dòng command báo như vậy.các bác xem giúp e vs.em cảm ơn nhiều.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
MRCEM    2

Em thấy bài này đã lâu, nay em cần lisp cũng tương tự, mạo muội cao nhân giúp đỡ.

Em muốn xin 1 cái lisp cũng viết chữ lên đoạn thẳng theo nhu cầu công việc của em được không ạ

- chữ viết từ trái theo phương ngang nằm trên hoặc dưới đoạn thẳng

- chữ viết từ dưới lên theo phương đứng bên trái hoặc phải đoạn thẳng

- chữ cách đoạn thẳng 80 hoặc tùy chỉnh

em đang mỏi tay chỉnh mong cao nhân giúp đỡ

 

Bạn thử dùng cái này xem. Kiểu chữ và chiều cao chữ do bạn chọn trước khi vào lệnh.

(defun c:int ()  (setq ss (ssget '((0 . "LINE")))	  chu (getstring "Chen chu :"))  (setq os (getvar "OSMODE"))  (setvar "OSMODE" 0)  (repeat (sslength ss)	(setq v  (ssname ss 0)	  p1 (cdr (assoc 10 (entget v)))	  p2 (cdr (assoc 11 (entget v)))	  pm (polar p1 (angle p1 p2) (* 0.5 (distance p1 p2)))	)	(command "text" "j" "MC" pm "" (* 180 (/ (angle p1 p2) pi)) chu)	(ssdel v ss)  )  (setvar "OSMODE" os))

EM MUỐN CHỈNH ĐƯỢC KHOẢNG CÁCH CHỮ ĐẾN ĐOẠN THẢNG VÀ VỊ TRÍ CHỮ ĐẶT TRÊN HOẶC DƯỚI LINE ĐƯỢC KHÔNG BÁC

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×